routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::redirect('/', 'welcome');

Auth::routes();

Route::group(['middleware' => ['auth', 'save_last_action_timestamp']], function () {
    Route::get('welcome', [\App\Http\Controllers\PageController::class, 'welcome'])->name('welcome');
    Route::get('consultation', [\App\Http\Controllers\PageController::class, 'consultation'])->name('consultation');
    Route::get('checklists/{checklist}', [\App\Http\Controllers\User\ChecklistController::class, 'show'])
        ->name('user.checklists.show');
    Route::get('tasklist/{list_type}', [\App\Http\Controllers\User\ChecklistController::class, 'tasklist'])
        ->name('user.tasklist');

    Route::group(['prefix' => 'admin', 'as' => 'admin.', 'middleware' => 'is_admin'], function () {
        Route::resource('pages', \App\Http\Controllers\Admin\PageController::class)
            ->only(['edit', 'update']);
        Route::resource('checklist_groups', \App\Http\Controllers\Admin\ChecklistGroupController::class);
        Route::resource('checklist_groups.checklists', \App\Http\Controllers\Admin\ChecklistController::class);
        Route::resource('checklists.tasks', \App\Http\Controllers\Admin\TaskController::class);

        Route::post('users/{user}/toggle_free_access', [\App\Http\Controllers\Admin\UserController::class, 'toggle_free_access'])
            ->name('users.toggle_free_access');
        Route::get('users', [\App\Http\Controllers\Admin\UserController::class, 'index'])->name('users.index');

        Route::post('images', [\App\Http\Controllers\Admin\ImageController::class, 'store'])->name('images.store');
    });
});

app/Http/Livewire/ChecklistShow.php
<?php

namespace App\Http\Livewire;

use App\Models\Task;
use Carbon\Carbon;
use Livewire\Component;

class ChecklistShow extends Component
{
    public $checklist;
    public $list_type;
    public $list_name;
    public $list_tasks;
    public $user_tasks;

    public $opened_tasks = [];
    public $completed_tasks = [];
    public ?Task $current_task;

    public $due_date_opened = FALSE;
    public $due_date;
    public $note_opened = FALSE;
    public $note;
    public $reminder_opened = FALSE;
    public $reminder_date;
    public $reminder_hour;

    public function mount()
    {
        $this->current_task = NULL;
        $this->reminder_date = now()->addDay()->toDateString();
        $this->reminder_hour = now()->hour;
    }

    public function render()
    {
        if (is_null($this->list_type)) {
            $this->list_name = $this->checklist->name;
            $this->list_tasks = $this->checklist->tasks->where('user_id', NULL);
            $this->user_tasks = $this->checklist->user_tasks()->get();
            $this->completed_tasks = $this->user_tasks->whereNotNull('completed_at')->pluck('task_id')->toArray();
        } else {
            switch ($this->list_type) {
                case 'my_day':
                    $this->list_name = __('My Day');
                    $this->user_tasks = Task::where('user_id', auth()->id())->whereNotNull('added_to_my_day_at')->get();
                    break;
                case 'important':
                    $this->list_name = __('Important');
                    $this->user_tasks = Task::where('user_id', auth()->id())->where('is_important', 1)->get();
                    break;
                case 'planned':
                    $this->list_name = __('Planned');
                    $this->user_tasks = Task::where('user_id', auth()->id())->whereNotNull('due_date')->orderBy('due_date')->get();
                    break;
            }
            $this->list_tasks = Task::whereIn('id', $this->user_tasks->pluck('task_id'))->get();
            $this->completed_tasks = $this->user_tasks->whereNotNull('completed_at')->pluck('task_id')->toArray();
        }

        return view('livewire.checklist-show');
    }

    public function toggle_task($task_id)
    {
        if (in_array($task_id, $this->opened_tasks)) {
            $this->opened_tasks = array_diff($this->opened_tasks, [$task_id]);
            $this->current_task = NULL;
        } else {
            $this->opened_tasks[] = $task_id;
            $this->current_task = Task::where('user_id', auth()->id())
                ->where('task_id', $task_id)
                ->first();
            if (!$this->current_task) {
                $task = Task::find($task_id);
                $this->current_task = $task->replicate();
                $this->current_task['user_id'] = auth()->id();
                $this->current_task['task_id'] = $task_id;
                $this->current_task->save();
            }
        }
    }

    public function complete_task($task_id)
    {
        $task = Task::find($task_id);
        if ($task) {
            $user_task = Task::where('task_id', $task_id)
                ->where('user_id', auth()->id())
                ->first();
            if ($user_task) {
                if (is_null($user_task->completed_at)) {
                    $user_task->update(['completed_at' => now()]);
                    $this->completed_tasks[] = $task_id;
                    $this->emit('task_complete', $task_id, $task->checklist_id);
                } else {
                    $user_task->update(['completed_at' => NULL]);
                    $this->emit('task_complete', $task_id, $task->checklist_id, -1);
                }
            } else {
                $user_task = $task->replicate();
                $user_task['user_id'] = auth()->id();
                $user_task['task_id'] = $task_id;
                $user_task['completed_at'] = now();
                $user_task->save();
                $this->completed_tasks[] = $task_id;
                $this->emit('task_complete', $task_id, $task->checklist_id);
            }
        }
    }

    public function add_to_my_day($task_id)
    {
        $user_task = Task::where('user_id', auth()->id())
            ->where('id', $task_id)
            ->first();
        if ($user_task) {
            if (is_null($user_task->added_to_my_day_at)) {
                $user_task->update(['added_to_my_day_at' => now()]);
                $this->emit('user_tasks_counter_change', 'my_day');
            } else {
                $user_task->update(['added_to_my_day_at' => NULL]);
                $this->emit('user_tasks_counter_change', 'my_day', -1);
            }
        } else {
            $task = Task::find($task_id);
            $user_task = $task->replicate();
            $user_task['user_id'] = auth()->id();
            $user_task['task_id'] = $task_id;
            $user_task['added_to_my_day_at'] = now();
            $user_task->save();
            $this->emit('user_tasks_counter_change', 'my_day');
        }
        $this->current_task = $user_task;
    }

    public function mark_as_important($task_id)
    {
        $user_task = Task::where('user_id', auth()->id())
            ->where(function ($query) use ($task_id) {
                $query->where('id', $task_id)
                    ->orWhere('task_id', $task_id);
            })
            ->first();
        if ($user_task) {
            if ($user_task->is_important == 0) {
                $user_task->update(['is_important' => 1]);
                $this->emit('user_tasks_counter_change', 'important');
            } else {
                $user_task->update(['is_important' => 0]);
                $this->emit('user_tasks_counter_change', 'important', -1);
            }
        } else {
            $task = Task::find($task_id);
            $user_task = $task->replicate();
            $user_task['user_id'] = auth()->id();
            $user_task['task_id'] = $task_id;
            $user_task['is_important'] = 1;
            $user_task->save();
            $this->emit('user_tasks_counter_change', 'important');
        }
        $this->current_task = $user_task;
    }

    public function toggle_due_date()
    {
        $this->due_date_opened = !$this->due_date_opened;
    }

    public function set_due_date($task_id, $due_date = NULL)
    {
        $user_task = Task::where('user_id', auth()->id())
            ->where(function ($query) use ($task_id) {
                $query->where('id', $task_id)
                    ->orWhere('task_id', $task_id);
            })
            ->first();
        if ($user_task) {
            if (is_null($due_date)) {
                $user_task->update(['due_date' => NULL]);
                $this->emit('user_tasks_counter_change', 'planned', -1);
            } else {
                $user_task->update(['due_date' => $due_date]);
                $this->emit('user_tasks_counter_change', 'planned');
            }
        } else {
            $task = Task::find($task_id);
            $user_task = $task->replicate();
            $user_task['user_id'] = auth()->id();
            $user_task['task_id'] = $task_id;
            $user_task['due_date'] = $due_date;
            $user_task->save();
            $this->emit('user_tasks_counter_change', 'planned');
        }
        $this->current_task = $user_task;
    }

    public function updatedDueDate($value)
    {
        $this->set_due_date($this->current_task->id, $value);
    }

    public function toggle_note()
    {
        $this->note_opened = !$this->note_opened;
        $this->note = $this->current_task->note;
    }

    public function save_note()
    {
        $this->current_task->update(['note' => $this->note]);
        $this->note_opened = FALSE;
    }

    public function toggle_reminder()
    {
        $this->reminder_opened = !$this->reminder_opened;
    }

    public function set_reminder($task_id, $reminder_date = NULL)
    {
        $user_task = Task::where('user_id', auth()->id())
            ->where('id', $task_id)
            ->first();

        $reminder_at = NULL;
        if ($reminder_date == 'custom') {
            $reminder_at = Carbon::create($this->reminder_date)
                ->setHour($this->reminder_hour)
                ->setMinute(0)
                ->setSecond(0)
                ->toDateTimeString();
        } else if (!is_null($reminder_date)) {
            $reminder_at = Carbon::create($reminder_date)
                ->setHour(now()->hour)
                ->setMinute(0)
                ->setSecond(0)
                ->toDateTimeString();
        }

        if ($user_task) {
            $user_task->update(['reminder_at' => $reminder_at]);
        } else {
            $task = Task::find($task_id);
            $user_task = $task->replicate();
            $user_task['user_id'] = auth()->id();
            $user_task['task_id'] = $task_id;
            $user_task['reminder_at'] = $reminder_at;
            $user_task->save();
        }
        $this->current_task = $user_task;
    }

}

app/Http/Livewire/CompletedTasksCounter.php
<?php

namespace App\Http\Livewire;

use Livewire\Component;

class CompletedTasksCounter extends Component
{
    public $completed_tasks = 0;
    public $tasks_count = 0;
    public $checklist_id;

    protected $listeners = ['task_complete' => 'recalculate_tasks'];

    public function render()
    {
        return view('livewire.completed-tasks-counter');
    }

    public function recalculate_tasks($task_id, $checklist_id, $count_change = 1)
    {
        if ($checklist_id == $this->checklist_id) {
            $this->completed_tasks += $count_change;
        }
    }
}

app/Http/Livewire/HeaderTotalsCount.php
<?php

namespace App\Http\Livewire;

use App\Models\Checklist;
use Livewire\Component;

class HeaderTotalsCount extends Component
{
    public $checklist_group_id;

    protected $listeners = ['task_complete' => 'render'];

    public function render()
    {
        $checklists = Checklist::where('checklist_group_id', $this->checklist_group_id)
            ->whereNull('user_id')
            ->withCount(['tasks' => function($query) {
                $query->whereNull('user_id');
            }])
            ->withCount(['user_tasks' => function($query) {
                $query->whereNotNull('completed_at');
            }])
            ->get();

        return view('livewire.header-totals-count', compact('checklists'));
    }
}

app/Http/Livewire/TasksTable.php
<?php

namespace App\Http\Livewire;

use App\Models\Task;
use Livewire\Component;

class TasksTable extends Component
{
    public $checklist;

    public function render()
    {
        $tasks = $this->checklist->tasks()->where('user_id', NULL)->orderBy('position')->get();

        return view('livewire.tasks-table', compact('tasks'));
    }

    public function task_up($task_id)
    {
        $task = Task::find($task_id);
        if ($task) {
            Task::whereNull('user_id')->where('position', $task->position - 1)->update([
                'position' => $task->position
            ]);
            $task->update(['position' => $task->position - 1]);
        }
    }

    public function task_down($task_id)
    {
        $task = Task::find($task_id);
        if ($task) {
            Task::whereNull('user_id')->where('position', $task->position + 1)->update([
                'position' => $task->position
            ]);
            $task->update(['position' => $task->position + 1]);
        }
    }
}

app/Http/Livewire/UserTasksCounter.php
<?php

namespace App\Http\Livewire;

use Livewire\Component;

class UserTasksCounter extends Component
{
    public string $task_type;
    public int $tasks_count;

    protected $listeners = [
        'user_tasks_counter_change' => 'recalculate_tasks',
    ];

    public function render()
    {
        return view('livewire.user-tasks-counter');
    }

    public function recalculate_tasks($task_type, $count_change = 1)
    {
        if ($this->task_type == $task_type) {
            $this->tasks_count += $count_change;
        }
    }
}

resources/views/livewire/checklist-show.blade.php
<div class="row">
    <div class="col-md-8">
        <div class="card">
            <div class="card-header">
                {{ $list_name }}
            </div>
            <div class="card-body">
                @if ($list_tasks->count())
                    <table class="table">
                        @foreach($list_tasks as $task)
                            @if ($loop->iteration == 6 && !Auth::user()->has_free_access && !Auth::user()->subscribed())
                                <tr>
                                    <td colspan="4" class="text-center">
                                        <h3>{{ __('You are limited at 5 tasks per checklist') }}</h3>
                                        <a href="/billing" class="btn btn-primary">{{ __('Unlock all now') }}</a>
                                    </td>
                                </tr>
                            @elseif ($loop->iteration <= 5 || Auth::user()->has_free_access || Auth::user()->subscribed())
                                <tr>
                                    <td width="5%">
                                        <input type="checkbox" wire:click="complete_task({{ $task->id }})"
                                               @if (in_array($task->id, $completed_tasks)) checked="checked" @endif />
                                    </td>
                                    <td width="90%">
                                        <a wire:click.prevent="toggle_task({{$task->id }})"
                                           href="#">{{ $task->name }}</a>
                                        @if ($user_tasks->where('task_id', $task->id)->first())
                                            <div style="font-style: italic; font-size: 11px">
                                                @if ($list_type)
                                                    {{ $task->checklist->name }} |
                                                @endif
                                                @if ($user_tasks->where('task_id', $task->id)->first()->added_to_my_day_at)
                                                    <span class="mr-2">
                                                    &#9788;
                                                    {{ __('My Day') }}
                                                </span>
                                                @endif
                                                @if ($user_tasks->where('task_id', $task->id)->first()->due_date)
                                                    <span class="mr-2">
                                                    &#9745;&nbsp;
                                                    {{ __('Due') }} {{ $user_tasks->where('task_id', $task->id)->first()->due_date->format('M d, Y') }}
                                                    </span>
                                                @endif
                                                @if ($user_tasks->where('task_id', $task->id)->first()->reminder_at)
                                                    <span class="mr-2">
                                                    &#9993;
                                                    </span>
                                                @endif
                                                @if ($user_tasks->where('task_id', $task->id)->first()->note)
                                                    <span class="mr-2">
                                                    &#9998;
                                                    </span>
                                                @endif
                                            </div>
                                        @endif
                                    </td>
                                    <td width="5%">
                                        @if (optional($user_tasks->where('task_id', $task->id)->first())->is_important)
                                            <a wire:click.prevent="mark_as_important({{ $task->id }})"
                                               href="#">&starf;</a>
                                        @else
                                            <a wire:click.prevent="mark_as_important({{ $task->id }})"
                                               href="#">&star;</a>
                                        @endif
                                    </td>
                                </tr>
                                @if (in_array($task->id, $opened_tasks))
                                    <tr>
                                        <td></td>
                                        <td colspan="3">{!! $task->description !!}</td>
                                    </tr>
                                @endif
                            @endif
                        @endforeach
                    </table>
                @else
                    {{ __('No tasks found') }}
                @endif
            </div>
        </div>
    </div>
    <div class="col-md-4">
        @if (!is_null($current_task))
            <div class="card">
                <div class="card-body">
                    <div class="float-right">
                        @if ($current_task->is_important)
                            <a wire:click.prevent="mark_as_important({{ $current_task->id }})" href="#">&starf;</a>
                        @else
                            <a wire:click.prevent="mark_as_important({{ $current_task->id }})" href="#">&star;</a>
                        @endif
                    </div>
                    <b>{{ $current_task->name }}</b>
                </div>
            </div>
            <div class="card">
                <div class="card-body">
                    &#9788;
                    &nbsp;
                    @if ($current_task->added_to_my_day_at)
                        <a wire:click.prevent="add_to_my_day({{ $current_task->id }})"
                           href="#">{{ __('Remove from My Day') }}</a>
                    @else
                        <a wire:click.prevent="add_to_my_day({{ $current_task->id }})"
                           href="#">{{ __('Add to My Day') }}</a>
                    @endif
                </div>
            </div>
            <div class="card">
                <div class="card-body">
                    &#9993;
                    &nbsp;
                    @if ($current_task->reminder_at)
                        {{ __('Reminder to be sent at') }} {{ $current_task->reminder_at->format('M j, Y H:i') }}
                        &nbsp;&nbsp;
                        <a wire:click.prevent="set_reminder({{ $current_task->id }})" href="#">{{ __('Remove') }}</a>
                    @else
                        <a wire:click.prevent="toggle_reminder" href="#">{{ __('Remind me') }}</a>
                        @if ($reminder_opened)
                            <ul>
                                <li>
                                    <a wire:click.prevent="set_reminder({{ $current_task->id }}, '{{ today()->addDay()->toDateString() }}')"
                                       href="#">{{ __('Tomorrow') }} {{ date('H') }}:00</a>
                                </li>
                                <li>
                                    <a wire:click.prevent="set_reminder({{ $current_task->id }}, '{{ today()->addWeek()->startOfWeek()->toDateString() }}')"
                                       href="#">{{ __('Next Monday') }} {{ date('H') }}:00</a>
                                </li>
                                <li>
                                    {{ __('Or pick a date & time') }}
                                    <div class="row">
                                        <div class="col-md-6">
                                            <input wire:model="reminder_date" class="form-control" type="date"/>
                                        </div>
                                        <div class="col-md-3">
                                            <select wire:model="reminder_hour" class="form-control">
                                                @foreach (range(0,23) as $hour)
                                                    <option value="{{ $hour }}">{{ $hour }}:00</option>
                                                @endforeach
                                            </select>
                                        </div>
                                        <div class="col-md-3">
                                            <button wire:click.prevent="set_reminder({{ $current_task->id }}, 'custom')"
                                                    class="btn btn-primary">{{ __('Save') }}</button>
                                        </div>
                                    </div>
                                </li>
                            </ul>
                        @endif
                    @endif
                    <hr/>
                    &#9745;
                    &nbsp;
                    @if ($current_task->due_date)
                        Due {{ $current_task->due_date->format('M j, Y') }}
                        &nbsp;&nbsp;
                        <a wire:click.prevent="set_due_date({{ $current_task->id }})" href="#">{{ __('Remove') }}</a>
                    @else
                        <a wire:click.prevent="toggle_due_date" href="#">{{ __('Add Due Date') }}</a>
                        @if ($due_date_opened)
                            <ul>
                                <li>
                                    <a wire:click.prevent="set_due_date({{ $current_task->id }}, '{{ today()->toDateString() }}')"
                                       href="#">{{ __('Today') }}</a>
                                </li>
                                <li>
                                    <a wire:click.prevent="set_due_date({{ $current_task->id }}, '{{ today()->addDay()->toDateString() }}')"
                                       href="#">{{ __('Tomorrow') }}</a>
                                </li>
                                <li>
                                    <a wire:click.prevent="set_due_date({{ $current_task->id }}, '{{ today()->addWeek()->startOfWeek()->toDateString() }}')"
                                       href="#">{{ __('Next week') }}</a>
                                </li>
                                <li>
                                    {{ __('Or pick a date') }}
                                    <br/>
                                    <input wire:model="due_date" type="date"/>
                                </li>
                            </ul>
                        @endif
                    @endif
                </div>
            </div>
            <div class="card">
                <div class="card-body">
                    &#9998;
                    &nbsp;
                    @if ($current_task->note)
                        <a wire:click.prevent="toggle_note" href="#">{{ __('Note') }}</a>
                        @if (!$note_opened)
                            <p>
                                {{ $current_task->note }}
                                <br/>
                                <a wire:click.prevent="toggle_note" href="#">{{ __('Edit') }}</a>
                            </p>
                        @endif
                    @else
                        <a wire:click.prevent="toggle_note" href="#">{{ __('Note') }}</a>
                    @endif
                    @if ($note_opened)
                        <div class="mt-4">
                            <textarea wire:model="note" class="form-control" rows="5"></textarea>
                            <button wire:click="save_note"
                                    class="btn btn-sm btn-primary mt-2">{{ __('Save Note') }}</button>
                        </div>
                    @endif
                </div>
            </div>
        @endif
    </div>
</div>

resources/views/livewire/completed-tasks-counter.blade.php
<span class="badge badge-info">
    {{ $completed_tasks }}/{{ $tasks_count }}
</span>

resources/views/livewire/header-totals-count.blade.php
<div class="row">
    <div class="col-md-6">
        <div class="card">
            <div class="card-header">
                {{ __('Store Review') }}
            </div>
            <div class="card-body">
                <div class="row">
                    <div class="col-md-8">
                        @foreach ($checklists as $checklist)
                            <div class="row mb-2">
                                <div class="col-md-5 text-right">
                                    <a class="font-weight-bold"
                                       href="{{ route('user.checklists.show', $checklist->id) }}">{{ $checklist->name }}</a>
                                </div>
                                <div class="col-md-7">
                                    <div class="progress progress-xs mt-2 mb-1">
                                        @if ($checklist->tasks_count > 0)
                                            <div class="progress-bar bg-success" role="progressbar"
                                                 style="width: {{ $checklist->user_tasks_count / $checklist->tasks_count * 100 }}%"
                                                 aria-valuenow="{{ $checklist->user_tasks_count / $checklist->tasks_count * 100 }}"
                                                 aria-valuemin="0"
                                                 aria-valuemax="100">
                                            </div>
                                        @else
                                            <div class="progress-bar bg-success" role="progressbar"
                                                 style="width: 0%"
                                                 aria-valuenow="0"
                                                 aria-valuemin="0"
                                                 aria-valuemax="100">
                                            </div>
                                        @endif
                                    </div>
                                    <strong>{{ $checklist->user_tasks_count }}/{{ $checklist->tasks_count }}</strong>
                                </div>
                            </div>
                        @endforeach
                    </div>
                    <div class="col-md-4">
                        <h2>{{ $checklists->sum('user_tasks_count') }}/{{ $checklists->sum('tasks_count') }}</h2>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

resources/views/livewire/tasks-table.blade.php
<table class="table table-responsive-sm">
    <tbody>
    @foreach ($tasks as $task)
        <tr>
            <td>
                @if ($task->position > 1)
                <a wire:click.prevent="task_up({{ $task->id }})" href="#">
                    &uarr;
                </a>
                @endif
                @if ($task->position < $tasks->max('position'))
                <a wire:click.prevent="task_down({{ $task->id }})" href="#">
                    &darr;
                </a>
                @endif
            </td>
            <td>{{ $task->name }}</td>
            <td>
                <a class="btn btn-sm btn-primary"
                   href="{{ route('admin.checklists.tasks.edit', [$checklist, $task]) }}">{{ __('Edit') }}</a>
                <form style="display: inline-block"
                      action="{{ route('admin.checklists.tasks.destroy', [$checklist, $task]) }}"
                      method="POST">
                    @csrf
                    @method('DELETE')
                    <button class="btn btn-sm btn-danger" type="submit"
                            onclick="return confirm('{{ __('Are you sure?') }}')"> {{ __('Delete') }}</button>
                </form>
            </td>
        </tr>
    @endforeach
    </tbody>
</table>

resources/views/livewire/user-tasks-counter.blade.php
<span class="badge badge-info">
    {{ $tasks_count }}
</span>